# This example shows how variable assignments are evaluated in Make.
#
# Try to run it as
#
# 	$ make -f ex05t-assign.mk

WIZARD = Saruman
WHO = $(WIZARD)
WIZARD = Gandalf

target:
	@echo $(WHO)

# As Aragorn, Legolas and Gimli in the Fangorn forest, you might expect Saruman
# to show up, but it is Gandalf (the White) instead. Hurray!

# This is because instead of evaluating ‹$(WIZARD)› on assignment, Make just
# remembers that “Value of WHO is value of WIZARD when it is used.”
#
# You can imagine it in a context of functional programming,
#
# 	echo $(WHO)
#
# will expand to
#
# 	echo $(WIZARD)
#
# because that's what value of ‹$(WHO)› was set to, and this expands to
#
# 	echo Gandalf
#
# One of the extended tutorials will showcase different kinds of assignment
# in GNU Make that may change this behaviour.
