#include <errno.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

#include "ack.h"

static
bool read_args(size_t len, long long args[len], char *argv[len])
{
	char *endp;

	for (int i = 0; i < len; ++i) {
		errno = 0;
		args[i] = strtol(argv[i + 1], &endp, 10);
		if (endp == argv[i + 1] || *endp != '\0' || errno != 0 || args[i] < 0) {
			fprintf(stderr, "%s: Invalid input\n", argv[i + 1]);
			return false;
		}
	}

	return true;
}

int main(int argc, char *argv[])
{
	if (argc != 3) {
		fprintf(stderr, "usage: %s M N\n", argv[0]);
		return EXIT_FAILURE;
	}

	long long args[2];
	if (!read_args(2, args, argv))
		return EXIT_FAILURE;

	printf("%lld\n", ack(args[0], args[1]));
	return EXIT_SUCCESS;
}
