#define _GNU_SOURCE

#include <assert.h>
#include <errno.h>
#include <ctype.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>

#include <getopt.h>

static
void version(const char *pname)
{
	/* TODO: Print program version. Some people like to dump AsciiArt here. */
}

static
void usage(FILE *stream, const char *pname)
{
	fprintf(stream, "Usage: %s [-c|-m] [-lw] [FILE]...\n", pname);
}

static
void help(const char *pname)
{
	usage(stdout, pname);
	printf(
			"Print newline, word and byte counts for each file.\n"
			"\n"
			"Brief summary of options and arguments:\n"
			"      --help           Print this text and exit.\n"
			"      --version        Print program version and exit.\n"
			"  -c, --bytes 			Print byte counts.\n"
			"  -m, --chars          Print character counts.\n"
			"  -l, --lines          Print newline counts.\n"
			"  -w, --words          Print word counts.\n"
			"\n"
			"  FILE 				File name.\n"
	);
}

/* These are helper functions to let you detect various cases. You can
 * reimplement them your own way if you wish to do so. */
static
bool is_byte(char c)
{
	return true;
}

static
bool is_char(char c)
{
	/* NOTE: Binary literals are GCC extensions. */
	return (c & 0b10000000) == 0 || (c & 0b11000000) == 0b11000000;
}

static
bool is_line(char c)
{
	return c == '\n';
}

static
bool is_word(char c)
{
	/* NOTE: Using ‹static› hidden variable for this task is rather ugly,
	 * but cleaner solution (passing context to the function) would be too
	 * complicated for this task which should be focused on arguments. */
	static char last = '\0';
	bool result = isalnum(last) && !isalnum(c);
	last = c;
	return result;
}

/* TODO: You are advised to store program options and arguments in this array.
 * Try to do as much pre-processing as possible, i.e. do not store raw ‹argv›,
 * but be more specific about the kind of argument.
 *
 * You are also free to ignore the advice above and do it your way :) */
//struct options {
//
//};

int main(int argc, char *argv[])
{
	// TODO: Fill in the function.
	return EXIT_FAILURE;
}
