#define _POSIX_C_SOURCE 200809L

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* This program is a base line of behaviour with no special features
 * involved. Run this program and try out to use keyboard shortcuts
 * you are used to do in shell, e.g. ‹Up›, ‹Ctrl-W›, ‹Ctrl-R›, … */

static inline
void prompt(const char *str)
{
	printf("%s", str);
	/* Standard C99 requires to use ‹fflush()› if we want to display above
	 * ‹printf()›'s output even without newline. */
	fflush(stdout);
}

int main(void)
{
	char *line = NULL;
	size_t size = 0;

	/* Sometimes, «very rarely», sequential operator can be useful.
	 * Almost. Mostly when it would lead to code duplication.
	 *
	 * Do not use it for ‹return perror(…), VALUE;› lest God's vengence
	 * will be upon you >:( */
	while (prompt("> "), getline(&line, &size, stdin) != -1) {
		char *nl = strchr(line, '\n');

		if (nl != NULL)
			*nl = '\0';

		printf("  [%s]\n", line);
	}

	free(line);
	return EXIT_SUCCESS;
}
