#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <err.h>

#include "strvec.h"

static
void usage(FILE *stream, const char *argv0)
{
	fprintf(stream, "usage: %s\n"
			"Strings are expected on standard input\n",
			argv0);
}

static
void chomp(char *line)
{
	char *nl = strchr(line, '\n');
	if (nl != NULL)
		*nl = '\0';
}

static
bool read_strings(struct strvec **vecp)
{
	char *line = NULL;
	size_t size = 0;

	while (getline(&line, &size, stdin) != -1) {
		chomp(line);
		if (strcmp(line, "") == 0)
			continue;

		if (!strvec_push(vecp, line))
			return false;

		line = NULL;
		size = 0;
	}

	if (ferror(stdin)) {
		warn("Failed to read from input");
		return false;
	}

	free(line);
	return true;
}

int main(int argc, char *argv[])
{
	/* TODO (1/3)
	 * Make the application aware of locale settings. */

	if (argc != 1) {
		usage(stderr, argv[0]);
		return EXIT_FAILURE;
	}

	struct strvec *sv;
	if (!strvec_create(&sv))
		return EXIT_FAILURE;

	int status = EXIT_FAILURE;
	if (!read_strings(&sv))
		goto cleanup;

	/* TODO (2/3)
	 * Sort the strings in ‹sv› according to the locale.
	 *
	 * TIP: Use ‹qsort()›, the number of elements is in ‹sv->size›,
	 *      the array of strings is in ‹sv->data›. */

	/* TODO (3/3)
	 * Print the sorted strings from ‹sv->data›. */



	/* Keep this line «after» your code! */
	status = EXIT_SUCCESS;

cleanup:
	strvec_clean(&sv);
	strvec_destroy(&sv);
	return status;
}
