#define _DEFAULT_SOURCE
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#include <err.h>

/* This short program demonstrates dangers of using ‹system()›. Notice
 * how the command is constructed for ‹system()›. Try it out like
 * this:
 *
 * 		$ ./hack today
 * 		$ ./hack 2 days ago
 *
 * Try it again with debugger.
 *
 * Now imagine this program runs as a backend to some web service. Can you
 * forge a request for this program that will, for example, create a new
 * file? */

int main(void)
{
	char cmd[1024];
	char *date = NULL;
	size_t date_size = 0;

	printf("> ");
	fflush(stdout);

	if (getline(&date, &date_size, stdin) == -1)
		err(EXIT_FAILURE, "Cannot read input");

	if (snprintf(cmd, sizeof(cmd), "date -d '%s'", date) > (int) sizeof(cmd))
		errx(EXIT_FAILURE, "Command too long");

	int status = EXIT_FAILURE;
	if (system(cmd) == 0)
		status = EXIT_SUCCESS;

	free(date);
	return status;
}
