#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>

#include <err.h>
#include <unistd.h>

/* This small program will only print its User IDs and exit. The point is
 * to demonstrate what happens when a process with credentials RUID ≠ 0,
 * EUID ≠ 0 and Saved-UID = 0 calls ‹execve()›.
 *
 * You should see Saved-UID changed to EUID. */
int main(int argc, char *argv[])
{
	uid_t ruid, euid, suid;
	if (getresuid(&ruid, &euid, &suid) != 0)
		err(EXIT_FAILURE, "geresuid");

	printf("User process privileges:\n");
	printf("  RUID      %5d\n", ruid);
	printf("  EUID      %5d\n", euid);
	printf("  Saved-UID %5d\n", suid);

	return EXIT_SUCCESS;
}
