#include "events.h"

#include <stdbool.h>
#include <stdio.h>
#include <string.h>

#include <sys/inotify.h>

/* NOTE: This is just an auxiliary file to hide non-important details.
 *       Work with ‹inotify.c›. */

#define EXPAND_EVENTS(EXPAND) \
	EXPAND(IN_ACCESS) \
	EXPAND(IN_ATTRIB) \
	EXPAND(IN_CLOSE_WRITE) \
	EXPAND(IN_CLOSE_NOWRITE) \
	EXPAND(IN_CREATE) \
	EXPAND(IN_DELETE) \
	EXPAND(IN_DELETE_SELF) \
	EXPAND(IN_MODIFY) \
	EXPAND(IN_MOVE_SELF) \
	EXPAND(IN_MOVED_FROM) \
	EXPAND(IN_MOVED_TO) \
	EXPAND(IN_OPEN) \
	EXPAND(IN_IGNORED) \
	EXPAND(IN_ISDIR) \

const char *events_to_str(uint32_t events)
{
	static char _str[256];
	sprintf(_str, "(0x%08x)", events);

	bool more = false;

	for (uint32_t bit = 0; bit < 32; ++bit) {
		const char *name = NULL;

		switch (events & (1 << bit)) {
#define EXPAND(NAME) \
		case (NAME): name = #NAME; break;
		EXPAND_EVENTS(EXPAND)
#undef EXPAND
		}

		if (name != NULL) {
			if (more || !(more = true))
				strcat(_str, " |");

			strcat(_str, " ");
			strcat(_str, name);
		}
	}

	return _str;
}
