#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <err.h>
#include <fcntl.h>
#include <sys/file.h>
#include <unistd.h>

/* NOTE: Since this task is only focused on locking, the following functions
 *       are already available for you: */

/* Program usage. */
static
void usage(const char *argv0, int exit_code)
{
	fprintf(stderr, "usage: %s <-r|-w> FILE\n", argv0);
	if (exit_code != 0)
		exit(exit_code);
}

/* Mode parsing for the first argument (-w or -r). */
enum mode {
	MODE_READ,
	MODE_WRITE,
};

static
enum mode get_mode(char *arg0, char *arg)
{
	if (strcmp(arg, "-r") == 0)
		return MODE_READ;
	if (strcmp(arg, "-w") == 0)
		return MODE_WRITE;

	usage(arg0, EXIT_FAILURE);
	__builtin_unreachable();
}

/* This tiny function copies contents of one descriptor to the other using
 * a buffer. */
static
void fcat(int fd_in, int fd_out)
{
	char buffer[512];
	ssize_t rd;
	while ((rd = read(fd_in, buffer, sizeof(buffer))) > 0) {
		if (write(fd_out, buffer, rd) != rd)
			err(EXIT_FAILURE, "fcat");
	}
}


int main(int argc, char *argv[])
{
	if (argc != 3)
		usage(argv[0], EXIT_FAILURE);

	/* Mode is either ‹MODE_READ› or ‹MODE_WRITE›. */
	enum mode mode = get_mode(argv[0], argv[1]);

	/* TODO:
	 *
	 * 1. Open a file in ‹argv[2]›. Mind the ‹mode› variable:
	 *    ◦ MODE_READ  ⇒ O_RDONLY
	 *    ◦ MODE_WRITE ⇒ O_WRONLY | O_CREAT */


	/*    NOTE: Write code for task 2 ABOVE this line. */
	printf("Acquiring lock…");
	fflush(stdout);

	/* 2. Lock the file using ‹flock()› call. Note that the call must block
	 *    until the lock is acquired. */


	/*    NOTE: Write code for task 2 ABOVE this line. */
	printf(" OK\n");

	/* 3. For ‹MODE_WRITE›, truncate the file and use ‹xcopy()› to copy
	 *    data from terminal into the file. For ‹MODE_READ›, just use
	 *    ‹fcat()› in the reverse direction. */


	return EXIT_SUCCESS;
}
