#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <err.h>
#include <sys/socket.h>
#include <sys/wait.h>
#include <unistd.h>

/* The program creates two related processes (parent and child) that will
 * demonstrate behaviour of various socket pair types. */


/* This intro part parses the first argument of the program to save you some
 * time in the seminar. You already know how to do this, so scroll down. */

#define EXPAND_SOCKET_TYPES(EXPAND) \
	EXPAND(STREAM) \
	EXPAND(DGRAM) \
	EXPAND(SEQPACKET)

static
int get_socket_type(const char *str)
{
#define EXPAND(STR) \
	if (strcmp(#STR, str) == 0) \
		return SOCK_ ## STR;
	EXPAND_SOCKET_TYPES(EXPAND);
#undef EXPAND

	return -1;
}

static
void exit_usage(int code, const char *argv0)
{
	fprintf(stderr, "usage: %s <STREAM|DGRAM|SEQPACKET>\n", argv0);
	exit(code);
}

void parent(int socket)
{
	/* TODO (1/3):
	 * Implement the parent process part. This function will receive a socket
	 * from ‹main()›. */

	/* 1. Create a buffer of 16 characters and fill it with an alphabet. */

	/* 2. Write the buffer to the socket 8 times, starting with 8 bytes
	 *    and writing one more byte each time. That is, you should write
	 *    “abcdefgh”, “abcdefghi”, “abcdefghij” etc. */

	/* 3. Finally, close the socket. */

}

void child(int socket)
{
	/* TODO (2/3):
	 * The child will receive the other socket from ‹main()› and will read
	 * from it. */

	/* 1. Create a buffer that will be able to hold 12 bytes (yes, even though
	 *    the parent writes 16 byte buffers). */

	/* 2. Read data from the socket into the buffer and print them to
	 *    standard output. */

	/* 3. When EOF is reached, close the socket. */

}


int main(int argc, char *argv[])
{
	if (argc != 2)
		exit_usage(EXIT_FAILURE, argv[0]);

	int sock_type = get_socket_type(argv[1]);
	if (sock_type == -1)
		exit_usage(EXIT_FAILURE, argv[0]);

	/* TODO (3/3):
	 * Here, we will create a socket pair and processes. */

	/* 1. Create a socket pair. The family shall be ‹AF_UNIX›,
	 *    the socket type is in ‹sock_type›. */

	/* 2. Create a new process.
	 *    • The child process shall close one of the socket and pass the other
	 *      to ‹child()› function. When this function exits, exit the program.
	 *    • The parent process shall close the other socket, and then pass
	 *      the first to the ‹parent()› function. */

	/* 3. Wait for the child process to terminate, and then exit the program. */

	return EXIT_SUCCESS;
}
